100 REM PROGRAM TO GET MAXIMUM LIKELIHOOD ESTIMATES OF THE
110 REM SLOPE AND INTERCEPT PARAMETERS FOR A SINGLE ITEM
120 REM UNDER A TWO PARAMETER LOGISTIC ICC MODEL
130 DIM X(10),RK(10),FK(10),PQ(10)
140 GOSUB 1500:REM READ CANNED DATA AND ESTABLISH TRACING
150 GOSUB 1000:REM MLE OF ITEM PARAMETERS
160 GOSUB 1700:REM PRINT ITEM PARAMETER ESTIMATES
170 END
1000 REM ITEMBIO SUBROUTINE
1030 FOR NIT=1 TO MAXIT
1035 PRINT:PRINT "ITERATION= ";NIT
1040 SFW=0:SFWV=0:SFWV2=0:SFWX=0:SFWXV=0:SFWV2=0:SFWX2=0
1050 FOR K=1 TO NXL:REM THETA LOOP
1060 IF FK(K)=0 GOTO 1180
1070 PI=RK(K)/FK(K)
1140 DEV=CPT+A*X(K)
1142 PH=1/(1+EXP(-DEV)):W=PH*(1-PH):IF W<.0000009 GOTO 1180
1145 V=(PI-PH)/W:IF TRALL<>0 GOTO 1160
1150 PRINT "X(";K;")= ";X(K);TAB(17);"PI= ";PI;TAB(30);"P HAT = ";PH
1155 PRINT TAB(17);"W= ";W;TAB(40);"V= ";V
1160 P1= FK(K)*W:P2=P1*V:P3=P2*V:P4=P1*X(K):P5=P4*X(K):P6=P4*V
1165 SFW=SFW+P1:SFWV=SFWV+P2:SFWX=SFWX+P4:SFWXV=SFWXV+P6
1170 SFWX2=SFWX2+P5:SFWV2=SFWV2+P3
1171 IF TRALL<>0 GOTO 1180
1172 PRINT TAB(5);"P1= ";P1;TAB(25);"P2= ";P2;TAB(40);"P3= ";P3
1173 PRINT TAB(5);"P4= ";P4;TAB(25);"P5= ";P5;TAB(40);"P6= ";P6
1174 PRINT TAB(5);"SFW= ";SFW;TAB(25);"SFWV= ";SFWV;TAB(45);"SFWX= ";SFWX
1175 PRINT TAB(5);"SFWXV= ";SFWXV;TAB(25);"SFWX2=";SFWX2;TAB(45);"SFWV2= ";SFWV2
1180 NEXT K
1190 IF SFW<=0 GOTO 1360
1200 DM=SFW*SFWX2-SFWX*SFWX:IF TRALL<>0 GOTO 1230
1210 PRINT TAB(5);"DENOMINATOR= ";DM
1230 IF DM<=.000099 GOTO 1350
1240 DCPT=(SFWV*SFWX2-SFWXV*SFWX)/DM
1250 DA=(SFW*SFWXV-SFWX*SFWV)/DM
1270 CPT=CPT+DCPT:A=A+DA
1275 IF (TRALL=0) OR (TRMLE=0) THEN
        PRINT "NIT= ";NIT;TAB(9);"INTERCEPT= ";CPT;TAB(32);"CHANGE= ";DCPT
        PRINT TAB(9);"SLOPE= ";A;TAB(32);"CHANGE= ";DA
        PRINT
     ELSE
     END IF
1290 IF(ABS(CPT)>30)OR(ABS(A)>20) GOTO 1360
1300 IF(ABS(DCPT)<=.05)AND(ABS(DA)<=.05) GOTO 1350
1330 NEXT NIT
1340 PRINT "REACHED MAXIMUM NUMBER OF ITERATIONS"
1350 RETURN
1360 PRINT "  OUT OF BOUNDS ERROR ";"ITERATION ";NIT:GOTO 1350
REM ***********CANNED DATA AND CONSTANTS***********
1500 NXL=10:CPT=0:A=1:REM INITIAL VALUES
1510 FOR K=1 TO NXL:READ X(K):NEXT K:REM READ ABILITY LEVELS
1520 FOR K=1 TO NXL:READ RK(K):NEXT K:REM READ NUMBER CORRECT RESPONSES
1530 FOR K=1 TO NXL:READ FK(K):NEXT K:REM READ NUMBER AT ABILITY LEVEL
1540 REM SET UP TRACE OF COMPUTATIONS
1550 TRALL=-1:TRMLE=-1
1560 INPUT "TRACE ALL? Y/N ";YN$
1570 IF (YN$="Y") OR (YN$="y") THEN TRALL=0:TRMLE=0:GOTO 1600
1580 INPUT "TRACE MLE? Y/N ";YN$
1590 IF (YN$="Y") OR (YN$="y") THEN TRMLE=0
1600 INPUT "ENTER NUMBER OF ITERATIONS TO DO ";MAXIT
1610 CLS:PRINT " ALL   MLE   MAX STAGES"
1620 PRINT TAB(3);TRALL;TAB(9);TRMLE;TAB(17);MAXIT
1630 RETURN
REM***********PRINT ITEM PARAMETER ESTIMATES***************
1700 DIFF=-CPT/A:DF=NXL-2
1710 PRINT "INTERCEPT= ";CPT;TAB(24);"SLOPE= ";A
1720 PRINT "DIFFICULTY= ";DIFF;TAB(30);"DISCRIMINATION= ";A
1730 PRINT "CHI-SQUARE= ";SFWV2;TAB(25);"D.F.= ";DF
1740 RETURN
REM *********CANNED DATA************************************
9400 REM ABILITY(X) LEVELS USED
9410 DATA -4.0000,-3.1111,-2.2222,-1.3333,-.4444,.4444,1.3333
9420 DATA 2.2222,3.1111,4.0000
9430 REM NUMBER OF CORRECT RESPONSES (RK) AT EACH ABILITY LEVEL
9440 DATA 6,17,20,34,51,68,81,90,95,97
9450 REM NUMBER OF EXAMINEES (FK) AT EACH ABILITY LEVEL
9460 DATA 100,100,100,100,100,100,100,100,100,100

