100 REM PROGRAM TO IMPLEMENT THE BIRNBAUM JOINT MAXIMUM LIKELIHOOD
110 REM ESTIMATION PARADIGM FOR THE RASCH MODEL.
120 DIM FDG(9),S(10),B(10),THETA(9)
130 GOSUB 3000:REM READ CANNED DATA,SET TRACES, GET INITIAL ESTIMATES
140 FIRST$="Y":LAST$="N"
150 FOR K=1 TO MAXCYCLE
160 PRINT "JMLE CYCLE= ";K
170 SUMB=0
180 GOSUB 1000:REM ESTIMATE ITEM DIFFICULTIES
190 IF(FIRST$ = "N") THEN GOTO 230
200 FIRST$="N"
210 BBOLD=BBAR
220 GOSUB 2000:GOTO 320
230 IF ABS(BBAR-BBOLD) > .05  THEN GOTO 210
240 REM REACHED CONVERGENCE
250 GOSUB 4000:REM CORRECT ITEM DIFFICULTY FOR BIAS
300 LAST$="Y"
310 GOSUB 2000
320 IF(LAST$="N") THEN GOTO 390
330 PRINT "ABILITY CORRECTED FOR BIAS"
340 FOR J=1 TO MAXSCORE
350 THETA(J)=THETA(J)*(NITEM-2)/NITEM
360 PRINT "THETA(";J;")= ";THETA(J)
370 NEXT J
380 IF LAST$="Y" THEN STOP
390 NEXT K
400 PRINT "MAX CYCLES REACHED"
410 GOSUB 4000: REM CORRECT ITEM DIFFICULTY FOR BIAS
420 GOTO 300
REM *******ITEM PARAMETER ESTIMATION SUBROUTINE******
1000 FOR I=1 TO NITEM
1010 FOR KK=1 TO MAXIT
1020 SUMFDGP=0:SUMFDGPQ=0
1030 FOR J=1 TO MAXSCORE
1040 IF TRALL <>0 GOTO 1060
1050 PRINT " ITEM= ";I;" NR ITERATION= ";KK;" RAW SCORE= ";J
1060 DEV=(THETA(J)-B(I))
1070 PIJ=1.0/(1+EXP(-DEV))
1080 SUMFDGP=SUMFDGP+FDG(J)*PIJ
1090 SUMFDGPQ=SUMFDGPQ+FDG(J)*PIJ*(1.0-PIJ)
1100 IF TRALL<>0 THEN GOTO 1120
1110 PRINT "DEV= ";DEV;TAB(17);"PIJ= ";PIJ;TAB(32);"SUMFDGP= ";SUMFDGP;TAB(52);"SUMFDGPQ= ";SUMFDGPQ
1120 NEXT J
1130 DELTAB=(S(I)-SUMFDGP)/SUMFDGPQ
1140 B(I)=B(I)-DELTAB
1150 IF (TRALL = 0) OR (TRITM= 0) THEN PRINT "DELTAB= ";DELTAB;TAB(25);"B(";I;")= ";B(I)
1160 IF ABS(DELTAB) < .05 THEN GOTO 1180
1170 NEXT KK
1180 SUMB=SUMB+B(I)
1190 NEXT I
1200 BBAR=SUMB/NITEM
1210 IF (TRALL=0) OR (TRITM=0) THEN
        PRINT "SUMB= ";SUMB;" BBAR= ";BBAR;" NITEM= ";NITEM
        FOR I=1 TO NITEM:B(I)=B(I)-BBAR:PRINT "B(";I;")= ";B(I):NEXT I
     ELSE
     END IF
1220 RETURN
REM *******ABILITY ESTIMATION BY RAW SCORE **********
2000 FOR J=1 TO MAXSCORE
2010 FOR KK=1 TO MAXIT
2020 SUMP=0.0:SUMPQ=0.0
2030 FOR I=1 TO NITEM
2040 DEV=(THETA(J)-B(I))
2050 PIJ=1.0/(1+EXP(-DEV))
2060 SUMP=SUMP+PIJ
2070 SUMPQ=SUMPQ+PIJ*(1.0-PIJ)
2080 IF TRALL <>0 GOTO 2110
2090 PRINT "RAW SCORE= ";J;" NR ITERATION= ";KK;" ITEM= ";I
2100 PRINT "DEV= ";DEV;" PIJ= ";PIJ;" SUMP= ";SUMP;" SUMPQ= ";SUMPQ
2110 NEXT I
2120 DELTA=(J-SUMP)/SUMPQ
2130 THETA(J)=THETA(J)+DELTA
2140 IF (TRALL=0) OR (TRABL=0) THEN PRINT "DELTA= ";DELTA;"THETA(";J;")= ";THETA(J)
2150 IF(ABS(DELTA)<.05) GOTO 2180
2160 NEXT KK
2170 IF (TRALL=0) OR (TRABL=0) THEN PRINT "THETA(";J;")= ";THETA(J)
2180 NEXT J
2190 RETURN
REM*********READ CANNED DATA, SET TRACES, GET INITAL ESTIMATES******
3000 NITEM=10:MAXSCORE=9:MAXCYCLE=10:MAXIT=5
3010 FOR J=1 TO MAXSCORE:READ FDG(J):NEXT J
3020 FOR I=1 TO NITEM:READ S(I):NEXT I
3030 TRALL=-1:TRITM=-1:TRABL=-1
3040 INPUT "TRACE ALL? Y/N ";YN$
3050 IF YN$="Y" THEN TRALL=0:TRITM=0:TRABL=0:GOTO 3110
3060 INPUT "TRACE ITEM MLE? Y/N ";YN$
3070 IF YN$="Y" THEN TRITM=0
3080 INPUT "TRACE ABILITY MLE? Y/N ";YN$
3090 IF YN$="Y" THEN TRABL=0
3100 REM CALCULATE INTIAL ESTIMATES
3110 N=0:FOR J=1 TO MAXSCORE:N=N+FDG(J):NEXT J:IF TRALL=0 THEN PRINT "N = ";N
3120 SUMI=0.0
3130 FOR I=1 TO NITEM
3140 B(I)=LOG((N-S(I))/S(I))
3150 SUMI=SUMI+B(I):IF TRALL=0 THEN PRINT "SUMI= ";SUMI;" B(";I";)= ";B(I)
3160 NEXT I
3170 MEANL=SUMI/10:IF TRALL=0 THEN PRINT "MEAN OF LOG TERMS= ";MEANL
3180 FOR I=1 TO NITEM
3190 B(I)=B(I)-MEANL:IF TRALL=0 THEN PRINT " INITIAL B(";I;")= ";B(I)
3200 NEXT I
3210 REM GET ABILITY ESTIMATES
3220 FOR J=1 TO MAXSCORE
3230 THETA(J)=LOG(J/(NITEM-J))
3240 IF TRALL=0 THEN PRINT "INITIAL THETA(";J;")= ";THETA(J)
3250 NEXT J
3260 RETURN
REM *******CORRECT ITEM DIFFFICULTY FOR BIAS***********
4000 PRINT "ITEM DIFFICULTY CORRECTED FOR BIAS"
4010 FOR I=1 TO NITEM
4020 B(I)=B(I)*((NITEM-1)/NITEM)
4030 PRINT "B(";I;")= ";B(I)
4040 NEXT I
4050 RETURN
REM *********CANNED DATA*********
8999 REM FREQUENCY OF RAW SCORES FOR 1 TO MAXSCORE
9000 DATA 53,85,127,148,163,120,135,95,50
9010 REM ITEM SCORE FREQUENCY
9020 DATA 497,622,366,522,508,381,436,526,400,628
