100 REM PROGRAM FOR BAYESIAN MODAL ESTIMATION OF  AN EXAMINEES ABILITY
110 REM UNDER A TWO-PARAMETER LOGISTIC ICC MODEL LSAT-6 DATA
120 DIM A(10), B(10), JIRP(10)
130 GOSUB 3000: REM READ CANNED DATA AND SET TRACES
140 THETA = 0: REM INITIAL ESTIMATE OF EXAMINEE'S ABILITY
150 GOSUB 2000: REM ESTIMATE ABILITY
160 PRINT "ESTIMATED ABILITY= "; THETA
170 STOP
REM ********END OF DRIVER SECTION
REM ********ABILITY ESTIMATION SUBROUTINE*******
2000 FOR NIT = 1 TO MAXIT
2010 SUMNUM = 0: SUMDEM = 0: REM CLEAR SUMS
2020 PRINT : PRINT "ITERATION= "; NIT: PRINT "ITERATION= "; NIT
2030 FOR I = 1 TO NITEM: REM ITEM LOOP
2040 UIJ = JIRP(I)
2050 DEV = A(I) * (THETA - B(I))
2060 PHAT = 1! / (1! + EXP(-DEV))
2090 WIJ = PHAT * (1! - PHAT)
2100 VIJ = (UIJ - PHAT)
2110 SUMNUM = SUMNUM + A(I) * VIJ
2120 SUMDEM = SUMDEM + A(I) * A(I) * WIJ
2130 IF (TRALL = -1) THEN GOTO 2190
2140 PRINT TAB(10); "ITEM= "; I
2150 PRINT TAB(5); "DIFFICULTY= "; B(I); TAB(28); "DISCRIMINATION= ";A(I);TAB(52);"THETA = ";THETA
2160 PRINT TAB(5); "UIJ= "; UIJ; TAB(20); "DEV= "; DEV; TAB(35); "P HAT = "; PHAT
2170 PRINT TAB(5); "WIJ= "; WIJ; TAB(25); "VIJ= "; VIJ
2180 PRINT TAB(5); "NUMERATOR SUM= "; SUMNUM; TAB(40); "DENOMINATOR SUM = "; SUMDEM: PRINT
2190 NEXT I
2300 SUMNUM = SUMNUM - (THETA - HPM) / HPVAR
2310 SUMDEM = -SUMDEM - (1! / HPVAR): REM MINUS SIGNS TO MATCH EQUATION 7.39
2320 IF TRALL <> 0 GOTO 2380
2330 PRINT TAB(5); "AFTER ADDING PRIOR TERMS"
2340 PRINT TAB(5); "NUMERATOR SUM= "; SUMNUM; TAB(40); "DENOMINATOR SUM = ";SUMDEM:PRINT
2380 DELTA = SUMNUM / SUMDEM
2390 IF (TRALL = 0) OR (TRBME = 0) THEN PRINT TAB(5); "CHANGE IN THETA="; DELTA
2400 IF (ABS(DELTA) < BIGT) GOTO 2430
2410 REM PROTECT AGAINST BIG CHANGE IN THETA
2420 IF (DELTA > 0!) THEN
     DELTA = BIGT
     ELSE
     DELTA = -BIGT
     END IF
2430 THETA = THETA - DELTA: REM CHANGE SUBBTRACTED AS PER EQUATION 7.40
2440 IF (TRALL = 0) OR (TRBME = 0) THEN PRINT "THETA=";THETA;TAB(20);"CHANGE = ";DELTA
2450 IF (ABS(DELTA) < .05) GOTO 2480
2460 NEXT NIT
2470 PRINT " REACHED MAX ITERATIONS"
2480 RETURN
REM *******READ CANNED DATA AND ESTABLISH TRACES*********
3000 NITEM = 5: BIGT = .5: HPM = 0!: HPVAR = 1: REM SET HYPERPARMETERS
3010 FOR I = 1 TO NITEM: READ JIRP(I): NEXT I
3020 FOR I = 1 TO NITEM: READ B(I): NEXT I
3030 FOR I = 1 TO NITEM: READ A(I): NEXT I
3050 TRALL = -1: TRBME = -1
3060 INPUT "TRACE ALL? Y/N "; YN$
3070 IF (YN$ = "Y") THEN TRALL = 0: TRBME = 0: GOTO 3100
3080 INPUT "TRACE BME? Y/N "; YN$
3090 IF (YN$ = "Y") THEN TRBME = 0
3100 INPUT "ENTER MAXIMUM NUMBER OF ITERATIONS TO DO "; MAXIT
3120 CLS : PRINT "ALL  MLE  MAX ITERATIONS"
3130 PRINT TAB(2); TRALL; TAB(6); TRBME; TAB(14); MAXIT
3140 RETURN
9500 DATA 1,0,1,0,1
9520 DATA -3.283,-1.317,-.285,-1.766,-2.858
9530 DATA .849,.758,.870,.736,.730

