100 REM MAXIMUM LIKELIHOOD ESTIMATION OF ITEM PARAMETERS FOR
110 REM A GRADED RESPONSE ITEM WITH FOUR ORDERED RESPONSE CATEGORIES
120 DIM PSTR(4),W(4),PK(4),POBS(4),CPT(3),SFD(4),T(4),PDELTA(4),B(3),BK(4)
130 DIM THETA(7),F(7),R(7,4),MTRX(4,4),TK(4,4)
160 GOSUB 1000:REM READ CANNED DATA AND ESTABLISH TRACE OF PROGRAM
170 FOR NIT=1 TO MAXIT
180 GOSUB 1100:REM CLEAR SUMS, VECTORS AND MATRIX
190 PRINT "MLE INTERATION ";NIT
200 FOR G= 1 TO MAXGPS:PRINT "ABILITY LEVEL ";G
210 GOSUB 1200:REM CALC P STAR
220 GOSUB 1300:REM CALC P OBSERVED
230 GOSUB 1400:REM CALCULATE FIRST DERIVATIVE TERMS FOR INTERCEPTS
240 GOSUB 1500:REM CALCULATE FIRST DERIVATIVE TERMS FOR SLOPE
250 GOSUB 1600:REM CALCULATE INTERCEPT TERMS FOR INFORMATION MATRIX
260 GOSUB 1800:REM CALCULATE SLOPE TERMS FOR INFORMATION MATRIX
270 NEXT G
280 GOSUB 2100:REM INVERT INFORMATION MATRIX
290 IF IFLAG=0 GOTO 370
300 GOSUB 2300:REM CALCULATE CHANGE VECTOR AND OBTAIN NEW PARAMETER ESTIMATES
310 GOSUB 2400:REM CALCULATE CONVERGENCE CRITERION
320 IF CONVERG$="Y" THEN GO TO 360
330 NEXT NIT
340 PRINT "REACHED MAXIMUM CYCLES"
360 GOSUB 3000:REM  PRINT ITEM PARAMETER ESTIMATES
370 END
REM ********READ CANNED DATA AND PRESTORE CONSTANTS ROUTINE******
1000 MRC=4:MBC=3:MAXIT=4:MAXGPS=7
1010 A=1:REM INITAL VALUE OF COMMON SLOPE
1020 FOR G=1 TO MAXGPS:READ THETA(G):NEXT G
1025 FOR G=1 TO MAXGPS:READ F(G):NEXT G
1027 FOR G=1 TO MAXGPS:FOR K=1 TO MRC
1030 READ R(G,K):NEXT K:NEXT G
1040 FOR Y=1 TO MBC:READ CPT(Y):NEXT Y
1050 INPUT "TRACE ALL COMPUTATIONS? Y/N ";YN$
1060 TRALL=-1:TRMLE=-1
1070 IF YN$="Y" THEN TRALL=0:TRMLE=0:GOTO 1091
1080 INPUT "TRACE MLE TERMS? Y/N ";YN$
1090 IF YN$="Y" THEN TRMLE=0
1091 PRINT "ALL  MLE  MAX CYCLES"
1092 PRINT TRMLE;TAB(6);TRMLE;TAB(13);MAXIT
1095 RETURN
REM *********CLEAR SUMS, VECTORS AND INFORMATION MATRIX*********
1100 FOR R=1 TO MRC:SFD(R)=0.0
1110 FOR C=1 TO MRC:MTRX(R,C)=0.0
1120 NEXT C:NEXT R
1130 RETURN
REM ********CALCULATE P STAR VALUES***********
1200 PSTR(0)=1.0:W(0)=0.0:PSTR(MRC)=0.0:W(MRC)=0.0
1205 IF TRALL=0 THEN PRINT "BOUNDARY CURVE PSTAR'S"
1210 FOR Y=1 TO MBC
1220 DEV=CPT(Y)+A*THETA(G)
1230 PSTR(Y)=1.0/(1+EXP(-DEV))
1240 W(Y)=PSTR(Y)*(1.0-PSTR(Y))
1250 IF TRALL=-1 GOTO 1280
1260 PRINT "CPT(";Y;")= ";CPT(Y);" A= ";A;" THETA(";G;")= ";THETA(G)
1270 PRINT TAB(5);"DEV= ";DEV;" PSTAR(";Y;")= ";PSTR(Y);" W(";Y;")=";W(Y)
1280 NEXT Y
1290 RETURN
REM ******CALCULATE OBSERVED PK AND PSTAR***********
1300 IF TRALL=0 THEN PRINT "PK AND P OBSERVED"
1305 FOR K=1 TO MRC
1310 IF(K=1) THEN PK(1)=1.0-PSTR(1): GOTO 1340
1320 IF(K=MRC) THEN PK(MRC)=PSTR(MBC):GOTO 1340
1330 PK(K)=PSTR(K-1)-PSTR(K)
1340 POBS(K)=R(G,K)/F(G)
1350 IF TRALL=0 THEN PRINT "K= ";K;" PK= ";PK(K);" POBS= ";POBS(K)
1360 NEXT K
1370 RETURN
REM *******CALCULATE FIRST DERIVATVE TERMS FOR INTERCEPTS*******
1400 IF TRALL=0 THEN PRINT "INTERCEPT TERMS"
1405 FOR Y=1 TO MBC
1410 TERM1=-(POBS(Y)/PK(Y))+(POBS(Y+1)/PK(Y+1))
1420 TERM2=F(G)*W(Y)*TERM1
1430 SFD(Y)=SFD(Y)+TERM2
1440 IF TRALL= -1 THEN GOTO 1460
1450 PRINT "Y= ";Y;" TERM1 = ";TERM1;" TERM2= ";TERM2;" FIRST DERIVATIVE = ";SFD(Y)
1460 NEXT Y
1470 RETURN
REM ********CALCULATE FIRST DERIVATIVE TERMS FOR COMMON SLOPE******
1500 SUMLS=0.0:IF TRALL=0 THEN PRINT "COMMON SLOPE TERMS"
1510 FOR K=1 TO MRC
1520 TERM1= W(K-1)-W(K)
1530 TERM2= (POBS(K)/PK(K))*TERM1
1540 SUMLS=SUMLS+TERM2
1550 IF TRALL=0 THEN PRINT "K= ";K;"TERM1= ";TERM1;" TERM2= ";TERM2;" SUMLS= ";SUMLS
1560 NEXT K
1570 TERM3=F(G)*THETA(G)*SUMLS
1580 SFD(MRC)= SFD(MRC)+TERM3
1590 IF TRALL=0 THEN PRINT "TERM3= ";TERM3;" FIRST DERIVATIVE TERM= ";SFD(MRC)
1595 RETURN
REM ********CALCULATE INTERCEPT TERMS IN INFORMATION MATRIX********
1600 IF TRALL=0 THEN PRINT "INTERCEPT TERMS IN INFORMATION MATRIX"
1610 FOR R=1 TO MBC
1620 FOR C=1 TO MBC
1630 IF R<>C THEN GO TO 1680
1640 REM DIAGONAL INTERCEPT TERM
1650 TERM1=1/PK(C)+1/PK(C+1)
1660 TERM2= F(G)*W(C)*W(C)*TERM1
1670 GOTO 1710
1680 IF ABS(R-C)>1 THEN GOTO 1720
1690 TERM1=F(G)*W(R)*W(C)
1700 IF R>C THEN
	TERM2=-(TERM1*(1/PK(R)))
     ELSE
	TERM2=-(TERM1*(1/PK(C)))
     END IF
1710 MTRX(R,C)=MTRX(R,C)+TERM2
1720 IF TRALL=0 THEN PRINT "R= ";R;" C= ";C;"TERM1= ";TERM1;" TERM2= ";TERM2;"MATRIX ELEMENT= ";MTRX(R,C)
1730 NEXT C:NEXT R:RETURN
REM *********CALCULATE SLOPE TERMS FOR INFORMATION MATRIX**********
1800 IF TRALL=0 THEN PRINT "SLOPE TERMS IN INFORMATION MATRIX"
1805 R=MRC:FOR C=1 TO MRC
1810 IF TRALL=0 THEN PRINT "R= ";R;" C= ";C
1815 IF C=MRC THEN GOTO 1850
1820 TERM1=(W(C-1)-W(C))/PK(C)-(W(C)-W(C+1))/PK(C+1)
1830 TERM2= -(F(G)*W(C)*THETA(G)*TERM1)
1840 GOTO 1910
1850 TERM2=0.0
1860 FOR K=1 TO MRC
1870 TERM1=(W(K-1)-W(K))*(W(K-1)-W(K))*1.0/PK(K)
1880 TERM2=TERM2+TERM1
1890 IF TRALL=0 THEN PRINT "K= ";K;"TERM1= ";TERM1;" TERM2= ";TERM2
1900 NEXT K
1905 TERM2=TERM2*F(G)*THETA(G)*THETA(G)
1910 MTRX(R,C)=MTRX(R,C)+TERM2
1920 IF TRALL=0 THEN PRINT "TERM1= ";TERM1;" TERM2= ";TERM2;" MATRIX ELEMENT= ";MTRX(R,C)
1930 NEXT C
1940 REM PUT SLOPE ROW DERIVATIVES IN LAST COLUMN
1950 FOR C=1 TO MRC
1960 MTRX(C,R)=MTRX(R,C)
1970 NEXT C
1980 IF TRALL=0 THEN PRINT "INFORMATION MATRIX"
1981 FOR R=1 TO MRC:FOR C=1 TO MRC
1982 IF TRALL=0 THEN PRINT "R= ";R;" C= ";C;" MATRIX ELEMENT= ";MTRX(R,C)
1984 NEXT C:NEXT R
1990 RETURN
REM********MATRIX INVERSION ROUTINE*******************
2100 IFLAG=-1
2105 FOR KK= 1 TO MRC
2110 IF (MTRX(1,1)-.000001)<=0 GOTO 2220
2120 R=SQR(MTRX(1,1))
2130 FOR IK= 1 TO MBC:T(IK)=MTRX(IK+1,1)/R:NEXT IK
2140 T(MRC)=1.0/R
2150 FOR JK=1 TO MBC
2160 FOR IK=1 TO MBC:MTRX(IK,JK)=MTRX(IK+1,JK+1)-T(IK)*T(JK)
2170 NEXT IK:NEXT JK
2180 FOR IK=1 TO MRC:MTRX(IK,MRC)=-T(IK)*T(MRC):NEXT IK
2190 FOR JK=1 TO MBC:MTRX(MRC,JK)=MTRX(JK,MRC):NEXT JK
2195 NEXT KK
2200 FOR JK=1 TO MRC:FOR IK=1 TO MRC:MTRX(IK,JK)=-MTRX(IK,JK):NEXT IK:NEXT JK
2210 GOTO 2240
2220 PRINT "THE MATRIX IS SINGULAR,VERY NEAR SINGULAR,OR INDEFINITE"
2230 IFLAG=0:GOTO 2270
2240 IF TRALL=-1 GOTO 2270
2250 FOR JK=1 TO MRC:FOR IK=1 TO MRC:PRINT "R= ";JK;" COL= ";IK;" INVER ELEMENT= ";MTRX(JK,IK)
2260 NEXT IK:NEXT JK
2270 RETURN
REM *************CALCULATE INCREMENTS TO ITEM PARMETER ESTIMATES**********
2300 FOR JK=1 TO MRC:PDELTA(JK)=0.0:NEXT JK
2310 FOR JK=1 TO MRC
2320 FOR IK=1 TO MRC
2330 PDELTA(JK)=PDELTA(JK)+MTRX(JK,IK)*SFD(IK)
2340 NEXT IK
2350 IF (TRALL=0) OR (TRMLE=0) THEN PRINT "DELTA PARAMETER(";JK;")= ";PDELTA(JK)
2355 NEXT JK
2360 REM MAY NEED BIG DELTA PROTECTION HERE
REM ********OBTAIN NEW ITEM PARAMETER VALUES********
2370 FOR IK=1 TO MBC:CPT(IK)=CPT(IK)+PDELTA(IK)
2380 IF (TRALL=0) OR (TRMLE=0) THEN PRINT "INTERCEPT(";IK;")= ";CPT(IK)
2385 NEXT IK
2390 A=A+PDELTA(MRC)
2392 IF (TRALL=O) OR (TRMLE=0) THEN PRINT "COMMON SLOPE = ";A
2395 RETURN
REM*********CHECK CONVERGENCE OF MLE *******************
2400 CONVERG$="N"
2410 FOR K=1 TO MRC
2420 IF ABS(PDELTA(K))>.05 GOTO 2450
2430 NEXT K:CONVERG$="Y"
2450 RETURN
REM********PRINT FINAL SOLUTION *************
3000 FOR Y=1 TO MBC:
3010 B(Y)= -CPT(Y)/A
3020 PRINT "INTERCEPT(";Y;") = ";CPT(Y);" BOUNDARY CURVE B(";Y;")= ";B(Y)
3030 NEXT Y:PRINT "COMMON SLOPE= ";A
3040 FOR K=1 TO MRC:IF K=1 THEN BK(K)=B(1): GOTO 3070
3050 IF K=MRC THEN BK(K)=B(MBC):GOTO 3070
3060 BK(K)=(B(K)+B(K-1))/2
3070 PRINT "RESPONSE CATEGORY(";K;") DIFFICULTY= ";BK(K)
3080 NEXT K:PRINT "ITEM DISCRIMINATION= ";A:RETURN
9000 REM THETA(G)
9010 DATA -3,-2,-1,0.0,1,2,3
9020 DATA 1000,1000,1000,1000,1000,1000,1000
9030 DATA 691,242,61,6
9040 DATA 500,341,136,23
9050 DATA 309,382,242,67
9060 DATA 159,341,341,159
9070 DATA 67,242,382,309
9080 DATA 23,136,341,500
9090 DATA 6,61,242,691
9100 DATA 1.8,0.0,-1.8



