100 REM PROGRAM TO ESTIMATE ITEM PARAMETERS UNDER NOMINAL RESPONSE MODEL
110 REM FOR 3 CATEGORY ITEM, 7 ABILITY GROUPS
120 DIM P(3),CP(2),AP(2),CPT(3),A(3),Z(3),EZ(3),F(7),T(4)
125 DIM TERM(4),FDS(4),PDELTA(4),THETA(7)
130 DIM TM(2,2),W(2,2),MTRX(4,4),R(7,3)
140 GOSUB 500:REM READ CANNED DATA,SET TRACES
150 GOSUB 600:REM TRANSFORM ITEM PARAMETERS
160 FOR NIT=1 TO MAXIT
170 PRINT:PRINT "MLE ITERATION ";NIT
180 GOSUB 700:REM CLEAR SUMS
190 FOR G=1 TO MAXGPS
200 IF TRALL=0 THEN PRINT:PRINT TAB(1);"ABILITY GROUP= ";G
210 GOSUB 1000:REM CALCULATE P'S
220 GOSUB 1200:REM CALCULATE FIRST DERIVATIVES
230 GOSUB 1400:REM CALCULATE W'S
240 GOSUB 2000:REM CALCULATE SECOND DERIVATIVES
250 NEXT G
255 GOSUB 2300:REM INVERT MATRIX
260 GOSUB 2500:REM CALCULATE INCREMENTS AND NEW CP,AP
280 GOSUB 2600:REM CALCULATE NEW CPT AND A'S
290 CONVERGE$="N"
300 GOSUB 2800:REM CHECK CONVERGENCE
310 IF CONVERGE$ = "Y" GOTO 340
320 NEXT NIT
330 PRINT "REACHED MAXIMUM ITERATIONS"
340 PRINT "FINAL VALUES":GOSUB 2640:REM PRINT FINAL INTERCEPTS AND SLOPES
350 END
REM*******READ CANNED DATA AND SET TRACES*********
500 MRC=3:NTP=2:MAXIT=5:MAXGPS=7
510 FOR K=1 TO MRC:READ CPT(K):READ A(K):NEXT K
520 FOR G= 1 TO MAXGPS:READ THETA(G):NEXT G
530 FOR G= 1 TO MAXGPS:READ F(G):FOR K=1 TO MRC:READ R(G,K):NEXT K:NEXT G
540 INPUT "TRACE ALL? Y/N ";YN$
550 TRALL=-1:TRMLE=-1
560 IF YN$ = "Y" THEN TRALL=0:TRMLE=0:GOTO 590
570 INPUT "TRACE MLE? Y/N ";YN$
580 IF YN$= "Y" THEN TRMLE=0
590 PRINT " ALL   MLE   MAX CYCLES"
593 PRINT TAB(3);TRALL;TAB(9);TRMLE;TAB(17);MAXIT
595 RETURN
REM********REPARAMETERIZE INTERCEPTS AND SLOPES ***********
600 IF TRALL=0 THEN PRINT "REPARAMETERIZED INTERCEPTS AND SLOPES"
605 FOR I=1 TO 2
610 IF I=1 THEN
     CP(I)=CPT(1)-CPT(2):AP(I)=A(1)-A(2)
    ELSE
     CP(I)=CPT(1)-CPT(3):AP(I)=A(1)-A(3)
    END IF
620 IF TRALL=0 THEN PRINT "CP(";I;")= ";CP(I);" A(I";I;")=";AP(I)
630 NEXT I
640 RETURN
REM*******CLEAR SUMS EACH ITERATION***********
700 FOR R=1 TO 4:FDS(R)=0:PDELTA(R)=0.0:FOR C= 1 TO 4:MTRX(R,C)=0:NEXT C:NEXT R
799 RETURN
REM*******CALCULATE P'S**************
1000 IF TRALL=0 THEN PRINT "EVALUATE MULTIVARIATE LOGISTIC FUNCTION"
1010 D=0:FOR K=1 TO MRC:IF TRALL=-1 GOTO 1020
1015 PRINT TAB(5);"CPT= ";CPT(K);" A= ";A(K);" THETA= ";THETA(G)
1020 Z(K)=CPT(K)+A(K)*THETA(G):EZ(K)=EXP(Z(K)):D=D+EZ(K)
1030 IF TRALL=0 THEN PRINT TAB(5);"Z(";K;")= ";Z(K);"EZ= ";EZ(K);"D=";D
1040 NEXT K
1050 FOR K=1 TO MRC:P(K)=EZ(K)/D
1060 IF TRALL=0 THEN PRINT TAB(10);"P(";K;")= ";P(K)
1070 NEXT K
1080 RETURN
REM*****CALCULATE FIRST DERIVATES*************
1200 IF TRALL=0 THEN PRINT "COMPUTE FIRST DERIVATIVES"
1205 FOR KK=1 TO 4
1210 IF KK=1 THEN TERM(KK)=-R(G,2)+F(G)*P(2)
1220 IF KK=2 THEN TERM(KK)=-R(G,3)+F(G)*P(3)
1230 IF KK=3 THEN TERM(KK)=THETA(G)*(-R(G,2)+F(G)*P(2))
1240 IF KK=4 THEN TERM(KK)=THETA(G)*(-R(G,3)+F(G)*P(3))
1250 FDS(KK)=FDS(KK)+TERM(KK)
1270 IF TRALL=-1 GOTO 1290
1280 PRINT "TERM(";KK;")= ";TERM(KK);" SUM FIRST DERIV(";KK;")=";FDS(KK)
1290 NEXT KK:RETURN
REM********CALCULATE W'S*************
1400 W(1,1)=P(2)*(1.0-P(2))
1410 W(1,2)=P(2)*P(3)
1420 W(2,1)=P(3)*P(2)
1430 W(2,2)=P(3)*(1.0-P(3))
1440 TM(1,1)=1:TM(1,2)=THETA(G):TM(2,1)=THETA(G):TM(2,2)=THETA(G)*THETA(G)
1450 IF TRALL=-1 GOTO 1490
1455 PRINT "WEIGHT AND THETA MATRICIES"
1460 FOR R=1 TO 2:FOR C=1 TO 2
1470 PRINT TAB(5);"R= ";R;" C= ";C;" W= ";W(R,C);"TM= ";TM(R,C)
1480 NEXT C:NEXT R
1490 RETURN
REM **************KRONECKER PRODUCT ROUTINE FOR SECOND DERIVATIVES***
2000 FOR IB=1 TO 2:FOR JB= 1 TO 2
2010 MF=TM(IB,JB)*F(G)
2020 IF(IB=1 AND JB=1) GOTO 2100
2030 IF(IB=1 AND JB=2) GOTO 2120
2040 IF(IB=2 AND JB=1) GOTO 2140
2050 IF(IB=2 AND JB=2) GOTO 2160
2060 STOP
2100 FOR I=1 TO 2:FOR J=1 TO 2
2101 TEMP=MF*W(I,J):IF I <> J THEN TEMP=-TEMP
2103 MTRX(I,J)=MTRX(I,J)+TEMP
2105 NEXT J:NEXT I:GOTO 2200
2120 FOR I=1 TO 2:FOR J=1 TO 2
2121 TEMP=MF*W(I,J):IF I <> J THEN TEMP=-TEMP
2123 MTRX(I,J+JB)=MTRX(I,J+JB)+TEMP
2125 NEXT J:NEXT I:GOTO 2200
2140 FOR I=1 TO 2:FOR J=1 TO 2
2141 TEMP=MF*W(I,J):IF I <> J THEN TEMP=-TEMP
2143 MTRX(I+IB,J)=MTRX(I+IB,J)+TEMP
2145 NEXT J:NEXT I:GOTO 2200
2160 FOR I=1 TO 2:FOR J=1 TO 2
2161 TEMP=MF*W(I,J):IF I <> J THEN TEMP=-TEMP
2163 MTRX(I+IB,J+JB)=MTRX(I+IB,J+JB)+TEMP
2165 NEXT J:NEXT I:GOTO 2200
2200 NEXT JB:NEXT IB:IF TRALL=-1 GOTO 2250
2210 PRINT "INFORMATION MATRIX"
2220 FOR R=1 TO 4:FOR C=1 TO 4
2230 PRINT TAB(5);"MTRX(";R;",";C;")= ";MTRX(R,C)
2240 NEXT C:NEXT R
2250 RETURN
2300 REM********MATRIX INVERSION ROUTINE*******************
2303 MBC=3
2305 FOR KK= 1 TO 4
2310 IF (MTRX(1,1)-.000001)<=0 GOTO 2220
2320 R=SQR(MTRX(1,1))
2330 FOR IK= 1 TO MBC:T(IK)=MTRX(IK+1,1)/R:NEXT IK
2340 T(4)=1.0/R
2350 FOR JK=1 TO MBC
2360 FOR IK=1 TO MBC:MTRX(IK,JK)=MTRX(IK+1,JK+1)-T(IK)*T(JK)
2370 NEXT IK:NEXT JK
2380 FOR IK=1 TO 4:MTRX(IK,4)=-T(IK)*T(4):NEXT IK
2390 FOR JK=1 TO MBC:MTRX(4,JK)=MTRX(JK,4):NEXT JK
2395 NEXT KK
2400 FOR JK=1 TO 4:FOR IK=1 TO 4:MTRX(IK,JK)=-MTRX(IK,JK):NEXT IK:NEXT JK
2410 GOTO 2440
2420 PRINT "THE MATRIX IS SINGULAR,VERY NEAR SINGULAR,OR INDEFINITE"
2430 IFLAG2=0:GOTO 2470
2440 IF TRALL<>0 GOTO 2470
2450 FOR JK=1 TO 4:FOR IK=1 TO 4:PRINT "ROW= ";JK;" COL= ";IK;" INVERSE ELEMENT= ";MTRX(JK,IK)
2460 NEXT IK:NEXT JK
2470 RETURN
REM*************CALCULATE NEW CP,AP*******
2500 FOR R=1 TO 4:FOR C=1 TO 4
2510 PDELTA(R)=PDELTA(R)+MTRX(R,C)*FDS(C)
2520 NEXT C
2530 IF(TRALL=0) OR (TRMLE=0) THEN PRINT "DELTA PARAMETER=";PDELTA(R)
2540 NEXT R
2550 CP(1)=CP(1)+PDELTA(1):CP(2)=CP(2)+PDELTA(2)
2560 AP(1)=AP(1)+PDELTA(3):AP(2)=AP(2)+PDELTA(4)
2570 IF (TRALL=0) OR (TRMLE=0) THEN GOSUB 2590
2580 RETURN
2590 PRINT "CP(1)= ";CP(1);"  AP(1)= ";AP(1)
2591 PRINT "CP(2)= ";CP(2);"  AP(2)= ";AP(2)
2592 RETURN
REM ************CALCULATE NEW INTERCEPTS AND SLOPES**********
2600 CPT(1)=(CP(1)+CP(2))/3:CPT(2)=(CP(2)-2*CP(1))/3
2605 CPT(3)=(CP(1)-2*CP(2))/3
2610 A(1)=(AP(1)+AP(2))/3:A(2)=(AP(2)-2*AP(1))/3:A(3)=(AP(1)-2*AP(2))/3
2620 IF (TRALL=0) OR (TRMLE=0) GOTO 2640
2630 GOTO 2660
2640 FOR K=1 TO MRC
2650 PRINT "INTERCEPT(";K;")= ";CPT(K);" SLOPE(";K;")=";A(K):NEXT K
2660 RETURN
REM*********CHECK CONVERGENCE***************
2800 FOR R=1 TO 4
2810 IF ABS(PDELTA(R)) >.05 GOTO 2830
2820 NEXT R:CONVERGE$="Y"
2830 RETURN
REM*******************CANNED DATA***************
9000 DATA -.80,-.30,.35,-.60,.45,.90
9110 DATA -3.0,-2.0,-1.0,0.0,1.0,2.0,3.0
9120 DATA 1000,57,938,5
9130 DATA 1000,97,873,30
9140 DATA 1000,143,707,150
9150 DATA 1000,139,377,484
9160 DATA 1000,71,106,823
9170 DATA 1000,25,20,955
9180 DATA 1000,7,4,989






