100 REM PROGRAM TO ESTIMATE EXAMINEE ABILITY PARAMETER
110 REM UNDER NOMINAL RESPONSE MODEL FOR FIVE 3-CATEGORY ITEMS
120 DIM P(3),CP(5,2),AP(5,2),CPT(5,3),A(5,3),Z(3),EZ(3)
130 DIM W,IRP(5),U(5)
140 GOSUB 500:REM READ CANNED DATA,SET TRACES
150 GOSUB 600:REM TRANSFORM ITEM PARAMETERS
160 FOR NIT=1 TO MAXIT
170 PRINT:PRINT "MLE ITERATION ";NIT
180 FDS=0:SDS=0:REM CLEAR SUMS
190 FOR I=1 TO NITEM
200 IF TRALL=0 THEN PRINT:PRINT TAB(1);"ITEM= ";I
210 GOSUB 1000:REM CALCULATE P'S
220 GOSUB 1200:REM CALCULATE FIRST DERIVATIVES
230 GOSUB 1400:REM CALCULATE W'S
240 GOSUB 2000:REM CALCULATE SECOND DERIVATIVES
250 NEXT I
270 GOSUB 2500:REM CALCULATE INCREMENTS AND NEW ABILITY
280 REM CHECK CONVERGENCE
290 IF ABS(TDELTA) <= .05  GOTO 310
300 NEXT NIT
310 PRINT "REACHED MAXIMUM ITERATIONS"
320 PRINT "FINAL ABILITY= ";THETA
330 END
REM*******READ CANNED DATA AND SET TRACES*********
500 MRC=3:NTP=2:NITEM=5:MAXIT=5:THETA=1:REM INITIAL VALUE OF THETA
510 FOR I=1 TO NITEM
520 FOR K=1 TO MRC:READ CPT(I,K):READ A(I,K)
530 NEXT K:NEXT I
540 FOR I=1 TO NITEM:READ IRP(I):NEXT I
550 INPUT "TRACE ALL? Y/N ";YN$
560 TRALL=-1:TRMLE=-1
570 IF YN$ = "Y" THEN TRALL=0:TRMLE=0:GOTO 593
580 INPUT "TRACE MLE? Y/N ";YN$
590 IF YN$= "Y" THEN TRMLE=0
593 PRINT " ALL   MLE   MAX CYCLES"
595 PRINT TAB(3);TRALL;TAB(9);TRMLE;TAB(17);MAXIT
597 RETURN
REM********REPARAMETERIZE INTERCEPTS AND SLOPES ***********
600 IF TRALL=0 THEN PRINT "REPARAMETERIZED INTERCEPTS AND SLOPES"
610 FOR I=1 TO NITEM
620 FOR K=1 TO 2
630 IF K=1 THEN
     CP(I,K)=CPT(I,1)-CPT(I,2):AP(I,K)=A(I,1)-A(I,2)
    ELSE
     CP(I,K)=CPT(I,1)-CPT(I,3):AP(I,K)=A(I,1)-A(I,3)
    END IF
640 IF TRALL=0 THEN PRINT "CP(";I;")= ";CP(I,K);" A(";I;")=";AP(I,K)
650 NEXT K:NEXT I
660 RETURN
REM*******CALCULATE P'S**************
1000 IF TRALL=0 THEN PRINT "EVALUATE MULTIVARIATE LOGISTIC FUNCTION"
1010 D=0:FOR K=1 TO MRC:IF TRALL=-1 GOTO 1030
1020 PRINT TAB(5);"CPT= ";CPT(I,K);" A= ";A(I,K);" THETA= ";THETA
1030 Z(K)=CPT(I,K)+A(I,K)*THETA:EZ(K)=EXP(Z(K)):D=D+EZ(K)
1040 IF TRALL=0 THEN PRINT TAB(5);"Z(";K;")= ";Z(K);"EZ= ";EZ(K);"D=";D
1050 NEXT K
1060 FOR K=1 TO MRC:P(K)=EZ(K)/D
1070 IF TRALL=0 THEN PRINT TAB(10);"P(";K;")= ";P(K)
1080 NEXT K
1090 RETURN
REM*****CALCULATE FIRST DERIVATES*************
1200 IF TRALL=0 THEN PRINT "COMPUTE FIRST DERIVATIVES"
1210 FOR K=1 TO MRC
1220 IF IRP(I)=K THEN
	U(K)=1
	ELSE
	U(K)=0
	END IF
1230 NEXT K
1240 TERM= -(AP(I,1)*(U(2)-P(2))+AP(I,2)*(U(3)-P(3)))
1250 FDS=FDS+TERM
1270 IF TRALL=-1 GOTO 1290
1280 PRINT "TERM = ";TERM;" SUM FIRST DERIV = ";FDS
1290 RETURN
REM********CALCULATE W'S*************
1400 W11=P(1)*(1.0-P(1))
1410 W12=P(1)*P(2)
1420 W21=W12
1430 W22=P(2)*(1.0-P(2))
1440 W13=P(1)*P(3)
1450 W23= P(2)*P(3)
1460 W33= P(3)*(1.0-P(3))
1470 IF TRALL=-1 GOTO 1495
1480 PRINT "WEIGHTS":PRINT TAB(5);"W11= ";W11;"  W12=W21= ";W12;"  W22= ";W22
1490 PRINT TAB(5);"W13= ";W13;"  W23= ";W23;"  W33= ";W33
1495 RETURN
REM *****CALCULATE SECOND DERIVATIVES*********
2000 IF TRALL=0 THEN PRINT "SECOND DERIVATIVE"
2010 TERM1=P(1)*(AP(I,1)*AP(I,1)*W12+AP(I,1)*AP(I,2)*W11+AP(I,2)*AP(I,2)*W13)/MRC
2020 TERM2=P(2)*(-AP(I,1)*AP(I,1)*W22-AP(I,1)*AP(I,2)*W21+AP(I,2)*AP(I,2)*W23)/MRC+AP(I,1)*AP(I,1)*W22-AP(I,1)*AP(I,2)*W23
2030 TERM3=P(3)*(AP(I,1)*AP(I,1)*W23-AP(I,1)*AP(I,2)*W13-AP(I,2)*AP(I,2)*W33)/MRC+AP(I,2)*AP(I,2)*W33-AP(I,1)*AP(I,2)*W23
2040 SDS=SDS+TERM1+TERM2+TERM3
2050 IF TRALL <>0 GOTO 2090
2060 PRINT "TERM1= ";TERM1
2070 PRINT "TERM2= ";TERM2
2080 PRINT "TERM3= ";TERM3;"   SDS= ";SDS
2090 RETURN
REM **********CALCULATE NEW ABILITY************
2500 TDELTA=FDS/SDS
2510 IF(TRALL=0) OR (TRMLE=0) THEN PRINT "DELTA PARAMETER=";TDELTA
2520 THETA=THETA+TDELTA
2530 IF (TRALL=0) OR (TRMLE=0) THEN GOSUB 2550
2540 RETURN
2550 PRINT "ABILITY= ";THETA
2560 RETURN
REM*********CHECK CONVERGENCE***************
2800 IF ABS(TDELTA) >.05 GOTO 2820
2810 CONVERGE$="Y"
2820 RETURN
REM*******************CANNED DATA***************
9000 DATA  .25,-.8,.50,1.0,-.75,-.20
9001 DATA  .50,1.0,.25,-.8,-.75,-.2
9002 DATA -.75,1.0,.50,-.20,.25,-.80
9003 DATA -.75,.2,.50,-1.0,.25,.8
9004 DATA  .25,-.8,-.75,1.0,.50,-.2
9005 DATA 3,3,1,2,2




