'     PROGRAM TO IMPLEMENT MARGINAL MAXIMUM LIKELIHOOD RASCH
'     SIMPLER RELAXATION SOLUTION

      TRALL = -1
      INPUT "TRACE ALL? Y/N "; YN$
      IF (YN$ = "Y") OR (YN$ = "y") THEN TRALL = 0
100   INPUT "ENTER NUMBER OF EM CYCLES "; MNC
      IF (MNC <= 0) THEN GOTO 100

      NI = 5
      NG = 6
'     G=0(1)5
      NL = 10
      NIT = 24
'     N.B. NIT = 4 * (NI + 1)
      CRITIT = .0001
      CRITNC = .001

      DIM RP(NG, NI), N(NG), X(NL), PHIX(NL), B(NI)
      DIM CX(NG, NL), PRODP(NL), SCXPHIX(NL), LX(NG, NL)
      DIM R1(NL, NI), R0(NL, NI), P(NL, NI), DB(NI), DDB(NI)
      DIM OLDB(NI)

      FOR L = 1 TO NL
        READ X(L)
      NEXT L
      DATA -4.5, -3.5, -2.5, -1.5, -0.5, 0.5, 1.5, 2.5, 3.5, 4.5

      FOR G = 0 TO (NG - 1)
        FOR I = 1 TO NI
          READ RP(G, I)
        NEXT I
      NEXT G
      DATA 0.0, 0.0, 0.0, 0.0, 0.0
      DATA 10.0, 1.0, 1.0, 2.0, 6.0
      DATA 62.0, 24.0, 7.0, 28.0, 49.0
      DATA 212.0, 109.0, 63.0, 139.0, 188.0
      DATA 342.0, 277.0, 184.0, 296.0, 329.0
      DATA 298.0, 298.0, 298.0, 298.0, 298.0

      FOR G = 0 TO (NG - 1)
        READ N(G)
      NEXT G
      DATA 3.0, 20.0, 85.0, 237.0, 357.0, 298.0

'     INITIAL VALUES
      A = 1!
      B(1) = 0!
      B(2) = 0!
      B(3) = 0!
      B(4) = 0!
      B(5) = 0!
      SUMN = 0!
      FOR G = 0 TO (NG - 1)
        SUMN = SUMN + N(G)
      NEXT G
      FOR I = 1 TO NI
        FOR G = 0 TO (NG - 1)
          B(I) = B(I) + RP(G, I)
        NEXT G
        B(I) = LOG((SUMN - B(I)) / B(I))
      NEXT I
      PRINT
      PRINT "INITIAL B(I)"
      PRINT
      PRINT "         I      B(I)"
      FOR I = 1 TO NI
        PRINT USING "####.#####"; I; B(I)
      NEXT I

      FOR L = 1 TO NL
        PI = 3.141592654#
        PHIX(L) = (1! / (SQR(2! * PI))) * EXP(-(1! / 2!) * X(L) * X(L))
      NEXT L

      NC = 1
1000  PRINT
      PRINT "CYCLE= "; NC

      FOR I = 1 TO NI
        OLDB(I) = B(I)
      NEXT I
      OLDA = A
'     FOR CRITNC

      FOR L = 1 TO NL
        PRODP(L) = 1!
        FOR I = 1 TO NI
          P(L, I) = 1! / (1! + EXP(-A * (X(L) - B(I))))
          PRODP(L) = PRODP(L) * P(L, I)
        NEXT I
      NEXT L

      FOR G = 0 TO (NG - 1)
        FOR L = 1 TO NL
          CX(G, L) = PRODP(L) * EXP(-(NI - G) * A * X(L))
'         PRINT "G= "; G; "  L= "; L; "  CX(G,L)="; CX(G, L)
        NEXT L
      NEXT G

      FOR G = 0 TO (NG - 1)
      SCXPHIX(G) = 0!
        FOR L = 1 TO NL
          SCXPHIX(G) = SCXPHIX(G) + CX(G, L) * PHIX(L)
        NEXT L
      NEXT G

      FOR G = 0 TO (NG - 1)
        FOR L = 1 TO NL
          LX(G, L) = CX(G, L) * PHIX(L) / SCXPHIX(G)
        NEXT L
      NEXT G

      FOR L = 1 TO NL
        FOR I = 1 TO NI
          R1(L, I) = 0!
          R0(L, I) = 0!
          FOR G = 0 TO (NG - 1)
            R1(L, I) = R1(L, I) + RP(G, I) * LX(G, L)
            R0(L, I) = R0(L, I) + (N(G) - RP(G, I)) * LX(G, L)
          NEXT G
        NEXT I
      NEXT L

      IF TRALL = 0 THEN
        PRINT
        PRINT "   ITERATION           I        B(I)       DB(I)      DDB(I)"
      END IF
      FOR I = 1 TO NI
        DB(I) = 0!
        DDB(I) = 0!
        FOR IT = 1 TO NIT
          FOR L = 1 TO NL
            P(L, I) = 1! / (1! + EXP(-A * (X(L) - B(I))))
            DB(I) = DB(I) + A * (R0(L, I) * P(L, I) - R1(L, I) * (1! - P(L, I)))
            DDB(I) = DDB(I) - A * A * P(L, I) * (1! - P(L, I)) * (R0(L, I) + R1(L, I))
          NEXT L
          IF TRALL = 0 THEN
            PRINT USING "######.#####"; IT; I; B(I); DB(I); DDB(I)
          END IF
          B(I) = B(I) - (DB(I) / DDB(I))
          IF (ABS(DB(I) / DDB(I)) < CRITIT) GOTO 700
        NEXT IT
700   NEXT I

      IF TRALL = 0 THEN
        PRINT
        PRINT "   ITERATION           A          DA         DDA"
      END IF
      FOR IT = 1 TO NIT
        DA = 0!
        DDA = 0!
        FOR L = 1 TO NL
          FOR I = 1 TO NI
            P(L, I) = 1! / (1! + EXP(-A * (X(L) - B(I))))
            DA = DA + (X(L) - B(I)) * (R1(L, I) * (1! - P(L, I)) - R0(L, I) * P(L, I))
            DDA = DDA - (X(L) - B(I)) * (X(L) - B(I)) * P(L, I) * (1! - P(L, I)) * (R0(L, I) + R1(L, I))
          NEXT I
        NEXT L
        IF TRALL = 0 THEN
          PRINT USING "######.#####"; IT; A; DA; DDA
        END IF
        A = A - (DA / DDA)
        IF (ABS(DA / DDA) < CRITIT) THEN
          GOTO 899
        END IF
      NEXT IT

899   PRINT
      PRINT "         I      B(I)"
      FOR I = 1 TO NI
        PRINT USING "####.#####"; I; B(I)
      NEXT I
      PRINT
      PRINT "         A"
      PRINT USING "####.#####"; A

      DIFFNC = ABS(A - OLDA)
      FOR I = 1 TO NI
        IF (ABS(B(I) - OLDB(I)) > DIFFNC) THEN
          DIFFNC = ABS(B(I) - OLDB(I))
        END IF
      NEXT I
      IF (DIFFNC < CRITNC) THEN
        PRINT
        PRINT "EM CYCLE CONVERGED AT NC= "; NC
        NC = MNC
      END IF
'     CRITNC MAY NOT BE EMPLOYED
      PRINT
      PRINT "        NC    DIFFNC"
      PRINT USING "####.#####"; NC; DIFFNC
      NC = NC + 1
      IF NC <= MNC GOTO 1000
      
      END

