      NL = 32: NI = 5: NQ = 20: NC = 50

      DIM ID$(NL)
      DIM U(NL, NI), X(NQ), AX(NQ), A(NI), B(NI), LUX(NL, NQ), HU(NL)
      DIM P(NI), PUX(NL, NQ), SUMP(NQ)
      DIM R(NL)

      A(1) = 1: A(2) = 1: A(3) = 1: A(4) = 1: A(5) = 1
      B(1) = -1.256: B(2) = .475: B(3) = 1.236: B(4) = .168: B(5) = -.623
      SUMR = 1000

REM   D=INTERVAL FOR SHEPPARD'S CORRECTION
      D = .5

      FOR L = 1 TO NL
        READ ID$(L), R(L), U(L, 1), U(L, 2), U(L, 3), U(L, 4), U(L, 5)
'     I = 1 TO NI
      NEXT L
      DATA 00000,  3,0,0,0,0,0
      DATA 00001,  6,0,0,0,0,1
      DATA 00010,  2,0,0,0,1,0
      DATA 00011, 11,0,0,0,1,1
      DATA 00100,  1,0,0,1,0,0
      DATA 00101,  1,0,0,1,0,1
      DATA 00110,  3,0,0,1,1,0
      DATA 00111,  4,0,0,1,1,1
      DATA 01000,  1,0,1,0,0,0
      DATA 01001,  8,0,1,0,0,1
      DATA 01010,  0,0,1,0,1,0
      DATA 01011, 16,0,1,0,1,1
      DATA 01100,  0,0,1,1,0,0
      DATA 01101,  3,0,1,1,0,1
      DATA 01110,  2,0,1,1,1,0
      DATA 01111, 15,0,1,1,1,1
      DATA 10000, 10,1,0,0,0,0
      DATA 10001, 29,1,0,0,0,1
      DATA 10010, 14,1,0,0,1,0
      DATA 10011, 81,1,0,0,1,1
      DATA 10100,  3,1,0,1,0,0
      DATA 10101, 28,1,0,1,0,1
      DATA 10110, 15,1,0,1,1,0
      DATA 10111, 80,1,0,1,1,1
      DATA 11000, 16,1,1,0,0,0
      DATA 11001, 56,1,1,0,0,1
      DATA 11010, 21,1,1,0,1,0
      DATA 11011,173,1,1,0,1,1
      DATA 11100, 11,1,1,1,0,0
      DATA 11101, 61,1,1,1,0,1
      DATA 11110, 28,1,1,1,1,0
      DATA 11111,298,1,1,1,1,1

      MU0 = 0
      SIGMA0 = 1

      PRINT
      PRINT "        MU       VAR     SIGMA"

      FOR C = 1 TO NC
'     CYCLE

        QNORMCON = 0
        FOR Q = 1 TO NQ
          X(Q) = -4.75 + (Q - 1) * D
          QNORMCON = QNORMCON + EXP(-(1 / 2) * ((X(Q) - MU0) / SIGMA0) ^ 2)
        NEXT Q
        FOR Q = 1 TO NQ
          AX(Q) = EXP(-(1 / 2) * ((X(Q) - MU0) / SIGMA0) ^ 2) / QNORMCON
        NEXT Q

        FOR L = 1 TO NL
          HU(L) = 0
          FOR Q = 1 TO NQ
            LUX(L, Q) = 1
          NEXT Q
        NEXT L

        FOR L = 1 TO NL
          FOR Q = 1 TO NQ
            FOR I = 1 TO NI
              P(I) = 1 / (1 + EXP(-(A(I) * (X(Q) - B(I)))))
              IF U(L, I) = 0 THEN P(I) = 1 - P(I)
              LUX(L, Q) = LUX(L, Q) * P(I)
            NEXT I
          NEXT Q
          HU(L) = 0
          FOR Q = 1 TO NQ
            HU(L) = HU(L) + LUX(L, Q) * AX(Q)
          NEXT Q
        NEXT L

        FOR L = 1 TO NL
          FOR Q = 1 TO NQ
            PUX(L, Q) = LUX(L, Q) * AX(Q) / HU(L)
          NEXT Q
        NEXT L

        MU = 0
        VAR = 0

        FOR Q = 1 TO NQ
          SUMP(Q) = 0
          FOR L = 1 TO NL
            SUMP(Q) = SUMP(Q) + PUX(L, Q) * R(L)
          NEXT L
          MU = MU + X(Q) * SUMP(Q)
        NEXT Q
        MU = MU / SUMR

        FOR Q = 1 TO NQ
          VAR = VAR + (X(Q) - MU) ^ 2 * SUMP(Q)
        NEXT Q
        VAR = VAR / SUMR

        SIGMA = SQR(VAR)

        PRINT USING "####.#####"; MU; VAR; SIGMA

        MU0 = MU
        SIGMA0 = SIGMA

      NEXT C

REM   SHEPPARD'S CORRECTION FOR FINAL ESTIMATE
      SHEVAR = VAR - D ^ 2 / 12
      SHESIGMA = SQR(VAR - D ^ 2 / 12)
      PRINT
      PRINT "        MU       VAR     SIGMA   SHEPVAR SHEPSIGMA"
      PRINT USING "####.#####"; MU; VAR; SIGMA; SHEVAR; SHESIGMA

REM   INFORMATION MATRIX
      SUMMU2 = 0
      SUMMUVAR = 0
      SUMVAR2 = 0

      FOR L = 1 TO NL
        TEMPMU2 = 0
        TEMPVAR2 = 0
        FOR Q = 1 TO NQ
          TEMPMU2 = TEMPMU2 + PUX(L, Q) * ((X(Q) - MU) / VAR)
          TEMPVAR2 = TEMPVAR2 + PUX(L, Q) * (((X(Q) - MU) ^ 2 - VAR) / (2 * VAR ^ 2))
        NEXT Q
        SUMMU2 = SUMMU2 + R(L) * TEMPMU2 ^ 2
        SUMMUVAR = SUMMUVAR + R(L) * TEMPMU2 * TEMPVAR2
        SUMVAR2 = SUMVAR2 + R(L) * TEMPVAR2 ^ 2
      NEXT L

      PRINT
      PRINT "     I(MU) I(MU,VAR)    I(VAR)"
      PRINT USING "####.#####"; SUMMU2; SUMMUVAR; SUMVAR2

      DET = SUMMU2 * SUMVAR2 - SUMMUVAR ^ 2
      VARMU = SUMVAR2 / DET
      VARVAR = SUMMU2 / DET
      COVMUVAR = -SUMMUVAR / DET
      SEMU = SQR(VARMU)
      SEVAR = SQR(VARVAR)

      PRINT
      PRINT "    SE(MU)   SE(VAR)     COVAR"
      PRINT USING "####.#####"; SEMU; SEVAR; COVMUVAR

      END
