/**
 * A program to estimate ability under graded response model for
 * five four-response test items. 
 */
import javax.swing.*; // for System.out.println
public class AppendixF1 {
  static final int MRC = 4; // nuMber of Response Categories
  static final int MBC = 3; // nuMber of Broundary Curves
  static final int NITEM = 5; // Nunber of ITEMs
  static final int MAXIT = 4; // MAXimum number of ITerations
  public static void main(String[] args) {
    double[] a = new double[NITEM]; // read canned data
      a[0] = 0.85;
      a[1] = 1.00;
      a[2] = 0.90;
      a[3] = 1.10;
      a[4] = 1.40;
    double[][] cpt = {
      { 1.72, 0.00, -1.72 },
      { 1.20, 0.20, -1.50 },
      { 2.10, 1.10, -0.70 },
      { -0.60, -0.80, -1.20 },
      { 1.40, 0.70, -1.70 }
    };
    double[] u = { 3.0, 2.0, 3.0, 4.0, 3.0 };
    double theta = 0.4; // initial value of theta
    int trall = -1; // set traces
    int trmle = -1;
    String yn = JOptionPane.showInputDialog
      ("Trace all? Y/N");
    if (yn.equalsIgnoreCase("y")) {
      trall = 0;
      trmle = 0;
    }
    else{
      String ynmle = JOptionPane.showInputDialog
        ("Trace MLE? Y/N");
      if (ynmle.equalsIgnoreCase("y")) {
        trmle = 0;
      }
      else {
        // normal processing
      } // end if (ynmle ...
    } // end if (yn ... else
    System.out.println("All= " + trall +
      "  MLE= " + trmle +
      "  Max Cycles= " + MAXIT);
    double fds = 0.0; // first derivative sum
    double sds = 0.0; // second derivative sum
    System.out.println("Initial Theta= " + theta);
    for (int nit = 1; nit <= MAXIT; nit++) {
      System.out.println("MLE Iteration= " + nit);
      for (int i = 0; i <= NITEM - 1; i++) {
        double term4 = 0.0;
        for (int k = 0; k <= MRC - 1; k++) {
          double k1 = k + 1.0; // casting
          if (u[i] == k1) {
            char ptsflg = 'n';
            // calc p's and w's
            int km1 = k - 1;
            double pstrkm1 = 1.0;
            double wkm1 = 0.0;
            double devkm1 = 0.0; // initialize
            if (km1 != -1){
              devkm1 = cpt[i][km1] + a[i] * theta;
              pstrkm1 = 1.0 / (1.0 + Math.exp(-devkm1));
              wkm1 = pstrkm1 * (1.0 - pstrkm1);
            }
            else {
              // normal processing
            } // end if (km1 ...
            double pstrk = 0.0;
            double wk = 0.0;
            double dev = 0.0; // initialize
            if (k != MRC -1) {
              dev = cpt[i][k] + a[i] * theta;
              pstrk = 1.0 / (1.0 + Math.exp(-dev));
              wk = pstrk * (1.0 - pstrk);
            }
            else {
              // normal processing
            } // end if (k ...
            double pk = pstrkm1 - pstrk;
            if (trall == 0) {
              System.out.println("Item(" + (i + 1) + ")" +
                "  U(I)= " + u[i]);
              System.out.println("K-1=" + k +
                "  Dev(K-1)= " + devkm1 +
                "  Pstar(K-1)= " + pstrkm1 +
                "  W(K-1)= " + wkm1);
              System.out.println("K=" + (k + 1) +
                "  Dev(K)= " + dev +
                "  Pstar(K)= " + pstrk +
                "  W(K)= " + wk);
            }
            else {
              // normal processing
            } // end if (trall ...
            if (pk < 0.0001 || pk > 0.9999) {
              ptsflg = 'y';
              break; // exit for (int k ...
            }
            else {
              // normal processing
            } // end if (pk ...
            // calc first and second derivative terms
            // first derivative
            double fterm = (wkm1 - wk) / pk;
            fds += fterm;
            if (trall == 0) {
              System.out.println("Fterm= " + fterm +
                "  First Derivative Sum= " + fds);
            }
            else {
              // normal processing
            } // end if (trall ...
            // second derivative
            double term1 = -wk * (1.0 - 2.0 * pstrk) / pk;
            double term2 = wkm1 * (1.0 - 2.0 * pstrkm1) / pk;
            double term3 = - (wkm1 - wk) * (wkm1 - wk) /
              (pk * pk);
            term4 += term1 + term2 + term3;
            sds += a[i] * a[i] * term4;
            if (trall == 0) {
              System.out.println("Term1= " + term1 +
                "  Term2= " + term2 +
                "  Term3= " + term3);
              System.out.println("Term4= " + term4 +
                "  Second Derivative Sum= " + sds);
            }
            else {
              // normal processing
            } // end if (trall ...
          }
          else {
            // normal processing
          } // end if (u[i] ...
        } // end for (int k ... (BASIC 230)
      } // end for (int i ... (BASIC 240)
      double delta = fds / sds;
      theta -= delta;
      if (trall == 0 || trmle == 0) {
        System.out.println("Theta= " + theta +
          "  Delta= " + delta);
      }
      else {
        // normal processing
      } // end if (trall ...
      if (Math.abs(delta) < 0.05) {
        break; // exit for (nit ...
      }
      else {
        // normal processing
      } // end if (Math.abs ...
      if (nit == MAXIT) {
         System.out.println("Maximum Cycles Reached");
      }
      else {
        // normal processing
      } // end if (nit ...
    } // end for (int nit ... (BASIC 280)
    System.out.println("Theta Estimate= " + theta);
    System.exit(0); // last line
  } // end public static ...
} // end public class ...
