/**
 * A program to estimate examinee ability parameter under
 * nominal response model for five three-category items.
 */
import javax.swing.*; // for System.out.println
public class AppendixG1 {
  static final int MRC = 3; // nuMber of Response Categories
  static final int NTP = 2; // Number of Transformed Parameters
  static final int NITEM = 5; // Number of ITEMs
  static final int MAXIT = 5; // MAXimum number of ITerations
  public static void main(String[] args) {
    double[] p = new double[MRC];
    double[][] cp = new double[NITEM][NTP];
    double[][] ap = new double[NITEM][NTP];
    double[] z = new double[MRC];
    double[] ez = new double[MRC];
    double[][] w = new double[NTP*2][NTP*2]; // matrix
    double[] u = new double[NITEM];
    double theta = 1.0; // initial value of theta
    double[][] cpt = { // read canned data
      { 0.25, 0.50, -0.75 },
      { 0.50, 0.25, -0.75 },
      { -0.75, 0.50, 0.25 },
      { -0.75, 0.50, 0.25 },
      { 0.25, -0.75, 0.50 }
    };
    double[][] a = {
      { -0.80, 1.00, -0.20 },
      { 1.00, -0.80, -0.20 },
      { 1.00, -0.20, -0.80 },
      { 0.20, -1.00, 0.80 },
      { -0.80, 1.00, -0.20 }
    };
    double[] irp = new double[NITEM];
    irp[0] = 3.0;
    irp[1] = 3.0;
    irp[2] = 1.0;
    irp[3] = 2.0;
    irp[4] = 2.0;
    int trall = -1; // set traces
    int trmle = -1;
    String yn = JOptionPane.showInputDialog
    ("Trace all? Y/N");
    if (yn.equalsIgnoreCase("y")) {
      trall = 0;
      trmle = 0;
    }
    else{
      String ynmle = JOptionPane.showInputDialog
        ("Trace MLE terms? Y/N");
      if (ynmle.equalsIgnoreCase("y")) {
        trmle = 0;
      }
      else {
        // normal processing
      } // end if (ynmle ...
    } // end if (yn ... else
    System.out.println("All= " + trall +
    "  MLE= " + trmle +
    "  Max Cycles= " + MAXIT);
    // transform item parameters (BASIC 600)
    if (trall == 0) {
      System.out.println(
        "Reparameterized Intercepts and Slopes");
    }
    else {
      // normal processing
    } // end if (trall ...
    for (int i = 0; i <= NITEM - 1; i++) {
      for (int k = 0; k <= NTP - 1; k++) {
        if (k == 0) {
          cp[i][k] = cpt[i][0] - cpt[i][1];
          ap[i][k] = a[i][0] - a[i][1];
        }
        else {
          cp[i][k] = cpt[i][0] - cpt[i][2];
          ap[i][k] = a[i][0] - a[i][2];
        } // end if (k ...
        if (trall == 0) {
          System.out.println("CP(" + (i + 1) +
            "," + (k + 1) + ")= " + cp[i][k] +
            "  AP(" + (i + 1) +
            "," + (k + 1) + ")= " + ap[i][k]);
        }
        else {
          // normal processing
        } // end if (trall ...
      } // end for (int k ...
    } // end for (int i ... (BASIC 650)
    for (int nit = 1; nit <= MAXIT; nit++) {
      System.out.println("MLE Iteration= " + nit);
      double fds = 0.0; // clear sums each iteration
      double sds = 0.0;
      for (int i = 0; i <= NITEM - 1; i++) {
        if (trall == 0) {
          System.out.println("Item= " + (i + 1));
        }
        else {
          // normal processing
        } // end if (trall ...
        // calculate p's  (BASIC 1000)
        if (trall == 0) {
          System.out.println(
            "Evaluate Multivariate Logistic Function");
        }
        else {
          // normal processing
        } // end if (trall ...
        double d = 0;
        for (int k = 0; k <= MRC - 1; k++) {
          z[k] = cpt[i][k] + a[i][k] * theta;
          ez[k] = Math.exp(z[k]);
          d += ez[k];
          if (trall == 0) {
            System.out.println("CPT= " + cpt[i][k] +
              "  A= " + a[i][k] +
              "  Theta= " + theta);
            System.out.println("Z(" + (k + 1) +
              ")= " + z[k] +
              "  EZ= " + ez[k] +
              "  D= " + d);
          }
          else {
            // normal processing
          } // end if (trall ...
        } // end for (int k ... (BASIC 1050)
        for (int k = 0; k <= MRC - 1; k++) {
          p[k] = ez[k] / d;
          if (trall == 0) {
            System.out.println("P(" + (k + 1) +
              ")= " + p[k]);
          }
          else {
            // normal processing
          } // end if (trall ...
        } // end for (int k ... (BASIC 1080)
        // calculate first derivatives (BASIC 1200)
        if (trall == 0) {
          System.out.println(
            "Compute First Derivatives");
        }
        else {
          // normal processing
        } // end if (trall ...
        for (int k = 0; k <= MRC - 1; k++) {
          if (irp[i] == k  + 1.0) { // casting
            u[k] = 1.0;
          }
          else {
            u[k] = 0.0;
          } // end if (irp ...
        } // end for (int k ...
        double term = -(ap[i][0] * (u[1] - p[1]) +
        ap[i][1] * (u[2] - p[2]));
        fds += term;
        if (trall == 0) {
          System.out.println("Term= " + term +
            "  Sum First Derivative= " + fds);
        }
        else {
          // normal processing
        } // end if (trall ... (BASIC 1290)
        // calculate w's  (BASIC 1400)
        w[0][0] = p[0] * (1.0 - p[0]);
        w[0][1] = p[0] * p[1];
        w[1][0] = w[0][1];
        w[1][1] = p[1] * (1.0 - p[1]);
        w[0][2] = p[0] * p[2];
        w[1][2] = p[1] * p[2];
        w[2][2] = p[2] * (1.0 - p[2]);
        if (trall == 0) {
          System.out.println("Weights");
          System.out.println("W11= " + w[0][0] +
            "  W12=W21= " + w[0][1] +
            "  W22= " + w[1][1]);
          System.out.println("W13= " + w[0][2] +
            "  W23= " + w[1][2] +
            "  W33= " + w[2][2]);
        }
        else {
          // normal processing
        } // end if (trall ... (BASIC 1495)
        // calculate second derivatives (BASIC 2000)
        double term1 = p[0] * (ap[i][0] * ap[i][0] * w[0][1] +
          ap[i][0] * ap[i][1] * w[0][0] +
          ap[i][1] * ap[i][1] * w[0][2]) / MRC;
        double term2 = p[1] * (-ap[i][0] * ap[i][0] * w[1][1] -
          ap[i][0] * ap[i][1] * w[1][0] +
          ap[i][1] * ap[i][1] * w[1][2]) / MRC +
          ap[i][0] * ap[i][0] * w[1][1] -
          ap[i][0] * ap[i][1] * w[1][2];
        double term3 = p[2] * (ap[i][0] * ap[i][0] * w[1][2] -
          ap[i][0] * ap[i][1] * w[0][2] -
          ap[i][1] * ap[i][1] * w[2][2]) / MRC +
          ap[i][1] * ap[i][1] * w[2][2] -
          ap[i][0] * ap[i][1] * w[1][2];
        sds += term1 + term2 + term3;
        if (trall == 0) {
          System.out.println("Term1= " + term1);
          System.out.println("Term2= " + term2);
          System.out.println("Term3= " + term3 +
            "  SDS= " + sds);
        }
        else {
          // normal processing
        } // end if (trall ... (BASIC 2090)
      } // end for (int i ... (BASIC 250)
      // calculate increments and new ability (BASIC 2500)
      double tdelta = fds / sds;
      theta += tdelta;
      if (trall == 0 || trmle == 0) {
        System.out.println("Delta Parameter= " + tdelta);
        System.out.println("Ability= " + theta);
      }
      else {
        // normal processing
      } // end if (trall ...
      // check convergence (BASIC 280)
      if (Math.abs(tdelta) <= 0.05) {
        System.out.println("Reached Final Value");
          break; // exit for (nit ...
      }
      else {
        // normal processing
      } // end if (Math ...
      if (nit == MAXIT) {
        System.out.println("Reached Maximum Cycles");
      }
      else {
        // normal processing
      } // end if (nit ...
    } // end for (int nit ... (BASIC 300)
    System.out.println("Final Ability= " + theta);
    System.exit(0); // last line
  } // end public static ...
} // end public class ...
