/**
 * AppendixI.java
 * Latent Population parameter estimation.
 */
import javax.swing.*; // for System.out.println
public class AppendixI {
  static final int NL = 32; // Number of theta Levels
  static final int NI = 5; // Number of items I
  static final int NQ = 20; // Number of Quadratures
  static final int NC = 50; // Number of em Cycles
  public static void main(String[] args) {
    double[] x = new double[NQ];
    double[] ax = new double[NQ];
    double[] hu = new double[NL];
    double[] p = new double[NI];
    double[] sump = new double[NQ];
    double[][] lux = new double[NL][NQ];
    double[][] pux = new double[NL][NQ];
    // item parameter values
    double[] a = new double[NI];
      a[0] = 1.0;
      a[1] = 1.0;
      a[2] = 1.0;
      a[3] = 1.0;
      a[4] = 1.0;
    double[] b = new double[NI];
      b[0] = -1.256;
      b[1] = 0.475;
      b[2] = 1.236;
      b[3] = 0.168;
      b[4] = -0.623;
    double sumr = 1000.0;
    double d = 0.5;
    // d = interval for Sheppard's correction
    double[][] u = {
      { 0.0, 0.0, 0.0, 0.0, 0.0 },
      { 0.0, 0.0, 0.0, 0.0, 1.0 },
      { 0.0, 0.0, 0.0, 1.0, 0.0 },
      { 0.0, 0.0, 0.0, 1.0, 1.0 },
      { 0.0, 0.0, 1.0, 0.0, 0.0 },
      { 0.0, 0.0, 1.0, 0.0, 1.0 },
      { 0.0, 0.0, 1.0, 1.0, 0.0 },
      { 0.0, 0.0, 1.0, 1.0, 1.0 },
      { 0.0, 1.0, 0.0, 0.0, 0.0 },
      { 0.0, 1.0, 0.0, 0.0, 1.0 },
      { 0.0, 1.0, 0.0, 1.0, 0.0 },
      { 0.0, 1.0, 0.0, 1.0, 1.0 },
      { 0.0, 1.0, 1.0, 0.0, 0.0 },
      { 0.0, 1.0, 1.0, 0.0, 1.0 },
      { 0.0, 1.0, 1.0, 1.0, 0.0 },
      { 0.0, 1.0, 1.0, 1.0, 1.0 },
      { 1.0, 0.0, 0.0, 0.0, 0.0 },
      { 1.0, 0.0, 0.0, 0.0, 1.0 },
      { 1.0, 0.0, 0.0, 1.0, 0.0 },
      { 1.0, 0.0, 0.0, 1.0, 1.0 },
      { 1.0, 0.0, 1.0, 0.0, 0.0 },
      { 1.0, 0.0, 1.0, 0.0, 1.0 },
      { 1.0, 0.0, 1.0, 1.0, 0.0 },
      { 1.0, 0.0, 1.0, 1.0, 1.0 },
      { 1.0, 1.0, 0.0, 0.0, 0.0 },
      { 1.0, 1.0, 0.0, 0.0, 1.0 },
      { 1.0, 1.0, 0.0, 1.0, 0.0 },
      { 1.0, 1.0, 0.0, 1.0, 1.0 },
      { 1.0, 1.0, 1.0, 0.0, 0.0 },
      { 1.0, 1.0, 1.0, 0.0, 1.0 },
      { 1.0, 1.0, 1.0, 1.0, 0.0 },
      { 1.0, 1.0, 1.0, 1.0, 1.0 }
    };
    String[] id = {
      "00000", "00001", "00010", "00011", "00100",
      "00101", "00110", "00111", "01000", "01001",
      "01010", "01011", "01100", "01101", "01110",
      "01111", "10000", "10001", "10010", "10011",
      "10100", "10101", "10110", "10111", "11000",
      "11001", "11010", "11011", "11100", "11101",
      "11110", "11111"
    };
    double[] r = {
      3, 6, 2, 11, 1, 1, 3, 4, 1, 8,
      0, 16, 0, 3, 2, 15, 10, 29, 14, 81,
      3, 28, 15, 80, 16, 56, 21, 173, 11, 61,
      28, 298
    };
    double mu0 = 0.0;
    double sigma0 = 1.0;
    for (int c = 0; c <= NC - 1; c++) {
      double qnormcon = 0.0;
      for (int q = 0; q <= NQ -1; q++) {
        x[q] = -4.75 + (q - 1.0) * d;
        qnormcon += Math.exp(-(1.0 / 2.0) *
          Math.pow((x[q] - mu0) / sigma0, 2));
      } // end for (int q ...
      for (int q = 0; q <= NQ - 1; q++) {
        ax[q] = Math.exp(-(1.0 / 2.0) *
          Math.pow((x[q] - mu0) / sigma0, 2)) / qnormcon;
      } // end for (int q ...
      for (int l = 0; l <= NL - 1; l++) {
        hu[l] = 0.0;
        for (int q = 0; q <= NQ - 1; q++) {
          lux[l][q] = 1.0;
        } // end for (int q ...
      } // end for (int l ...
      for (int l = 0; l <= NL - 1; l++) {
        for (int q = 0; q <= NQ - 1; q++) {
          for (int i = 0; i <= NI - 1; i++) {
            p[i] = 1.0 / (1.0 + Math.exp(- a[i] * (x[q] - b[i])));
            if (u[l][i] == 0.0) p[i] = 1.0 - p[i];
            lux[l][q] *= p[i];
          } // end for (int i ...
        } // end for (int q ...
        hu[l] = 0.0;
        for (int q = 0; q <= NQ - 1; q ++) {
          hu[l] += lux[l][q] * ax[q];
        } // end for (int q ...
      } // end for (int l ...
      for (int l = 0; l <= NL - 1; l++) {
        for (int q = 0; q <= NQ - 1; q++) {
          pux[l][q] = lux[l][q] * ax[q] / hu[l];
          } // end for (int q ...
      } // end for (int l ...
      double mu = 0.0;
      double var = 0.0;
      for (int q = 0; q <= NQ - 1; q++) {
        sump[q] = 0.0;
        for (int l = 0; l <= NL - 1; l++) {
          sump[q] += pux[l][q] * r[l];
        } // end for (int l ...
        mu += x[q] * sump[q];
      } // end for (int q ...
      mu /= sumr;
      for (int q = 0; q <= NQ - 1; q++) {
        var += Math.pow(x[q] - mu, 2) * sump[q];
      } // end for (int q ...
      var /= sumr;
      double sigma = Math.sqrt(var);
      System.out.println("Cycle= " + (c + 1) +
        "  MU= " + mu +
        "  VAR= " + var +
        "  SIGMA= " + sigma);
      mu0 = mu;
      sigma0 = sigma;
      if (c == NC - 1) {
      // Sheppard's correction for final estimates
        double shevar = var - Math.pow(d, 2) / 12.0;
        double shesigma = Math.sqrt(shevar);
        System.out.println("MU= " + mu +
          "  VAR= " + var +
          "  SIGMA= " + sigma);
        System.out.println("Sheppard VAR= " + shevar +
          "  Sheppard SIGMA= " + shesigma);
        // information matrix
        double summu2 = 0.0;
        double summuvar = 0.0;
        double sumvar2 = 0.0;
        for (int l = 0; l <= NL - 1; l++) {
          double tempmu2 = 0.0;
          double tempvar2 = 0.0;
          for (int q = 0; q <= NQ - 1; q++) {
            tempmu2 += pux[l][q] * ((x[q] - mu) / var);
            tempvar2 += pux[l][q] *
             (Math.pow(x[q] - mu, 2) - var) / (2.0 * Math.pow(var, 2));
          } // end for (int q ...
          summu2 += r[l] * tempmu2 * tempmu2;
          summuvar += r[l] * tempmu2 * tempvar2;
          sumvar2 += r[l] * tempvar2 * tempvar2;
        } // end for (int l ..
        System.out.println("I(MU)= " + summu2 +
          "  I(MU,VAR)= " + summuvar +
          "  I(VAR)= " + sumvar2);
        double det = summu2 * sumvar2 - summuvar * summuvar;
        double varmu = sumvar2 / det;
        double varvar = summu2 / det;
        double covmuvar = - summuvar / det;
        double semu = Math.sqrt(varmu);
        double sevar = Math.sqrt(varvar);
        System.out.println("SE(MU)= " + semu +
          "  SE(VAR)= " + sevar +
          "  COVAR= " + covmuvar);
      }
      else {
        // normal processing
      } // end if (c ... else
    } // end for (int c ...
    System.exit(0); // last line
  } // end public static ...
} // end public class ...
