postscript("fig8-5.eps",width=3.5,height=2.5,pointsize=7)
par(mfrow=c(1,1),lab=c(8,3,3))
theta<-seq(-3,3,.1)
alpha<-.5
sigma<-1/alpha
beta1<--2
beta2<-0
beta3<-2
bcc1<-pnorm(theta,beta1,sigma)
bcc2<-pnorm(theta,beta2,sigma)
bcc3<-pnorm(theta,beta3,sigma)
p1<-1-bcc1 #bcc0=1
p2<-bcc1-bcc2
p3<-bcc2-bcc3
p4<-bcc3-0 #bcc4=0
h1<-dnorm(theta,beta1,sigma)
h2<-dnorm(theta,beta2,sigma)
h3<-dnorm(theta,beta3,sigma)
dp1<-0-h1 #h0=0
dp2<-h1-h2
dp3<-h2-h3
dp4<-h3-0 #h4=0
ddp1<--alpha^2*(0-(theta-beta1)*h1)
ddp2<--alpha^2*((theta-beta1)*h1-(theta-beta2)*h2)
ddp3<--alpha^2*((theta-beta2)*h2-(theta-beta3)*h3)
ddp4<--alpha^2*((theta-beta3)*h3-0)
i1<-dp1^2/p1-ddp1
i2<-dp2^2/p2-ddp2
i3<-dp3^2/p3-ddp3
i4<-dp4^2/p4-ddp4
i<-i1+i2+i3+i4
plot(theta,i,type="l",xlim=c(-3,3),ylim=c(0,.3),xlab="Ability",
  ylab="Item Information",bty="l")
di<-h2^2/(bcc2*(1-bcc2))
par(new=T)
plot(theta,di,type="l",xlim=c(-3,3),ylim=c(0,.3),xlab="",ylab="",bty="l")
text(2.0,.23,"Graded Response")
text(1.7,.06,"Dichotomous Response")
dev.off()
dos("copy fig8-5.eps lpt1")
